Index: gcc/ChangeLog
===================================================================
--- gcc/ChangeLog	(.../tags/gcc_5_2_0_release)	(wersja 225879)
+++ gcc/ChangeLog	(.../branches/gcc-5-branch)	(wersja 225879)
@@ -1,3 +1,7 @@
+2015-07-16  Richard Biener  <rguenther@suse.de>
+
+	* BASE-VER: Set to 5.2.1.
+
 2015-07-16  Release Manager
 
 	* GCC 5.2.0 released.
Index: gcc/testsuite/ChangeLog
===================================================================
--- gcc/testsuite/ChangeLog	(.../tags/gcc_5_2_0_release)	(wersja 225879)
+++ gcc/testsuite/ChangeLog	(.../branches/gcc-5-branch)	(wersja 225879)
@@ -1,3 +1,11 @@
+2015-07-16  Marek Polacek  <polacek@redhat.com>
+
+	Backported from mainline
+	2015-07-08  Marek Polacek  <polacek@redhat.com>
+
+	PR c++/66748
+	* g++.dg/abi/abi-tag15.C: New test.
+
 2015-07-16  Release Manager
 
 	* GCC 5.2.0 released.
Index: gcc/testsuite/g++.dg/abi/abi-tag15.C
===================================================================
--- gcc/testsuite/g++.dg/abi/abi-tag15.C	(.../tags/gcc_5_2_0_release)	(wersja 0)
+++ gcc/testsuite/g++.dg/abi/abi-tag15.C	(.../branches/gcc-5-branch)	(wersja 225879)
@@ -0,0 +1,3 @@
+// PR c++/66748
+
+enum __attribute__((abi_tag("foo"))) E {}; // { dg-error "redeclaration of" }
Index: gcc/cp/tree.c
===================================================================
--- gcc/cp/tree.c	(.../tags/gcc_5_2_0_release)	(wersja 225879)
+++ gcc/cp/tree.c	(.../branches/gcc-5-branch)	(wersja 225879)
@@ -3602,13 +3602,15 @@
 		 name, *node);
 	  goto fail;
 	}
-      else if (CLASSTYPE_TEMPLATE_INSTANTIATION (*node))
+      else if (CLASS_TYPE_P (*node)
+	       && CLASSTYPE_TEMPLATE_INSTANTIATION (*node))
 	{
 	  warning (OPT_Wattributes, "ignoring %qE attribute applied to "
 		   "template instantiation %qT", name, *node);
 	  goto fail;
 	}
-      else if (CLASSTYPE_TEMPLATE_SPECIALIZATION (*node))
+      else if (CLASS_TYPE_P (*node)
+	       && CLASSTYPE_TEMPLATE_SPECIALIZATION (*node))
 	{
 	  warning (OPT_Wattributes, "ignoring %qE attribute applied to "
 		   "template specialization %qT", name, *node);
Index: gcc/cp/ChangeLog
===================================================================
--- gcc/cp/ChangeLog	(.../tags/gcc_5_2_0_release)	(wersja 225879)
+++ gcc/cp/ChangeLog	(.../branches/gcc-5-branch)	(wersja 225879)
@@ -1,3 +1,12 @@
+2015-07-16  Marek Polacek  <polacek@redhat.com>
+
+	Backported from mainline
+	2015-07-08  Marek Polacek  <polacek@redhat.com>
+
+	PR c++/66748
+	* tree.c (handle_abi_tag_attribute): Check for CLASS_TYPE_P before
+	accessing TYPE_LANG_SPECIFIC node.
+
 2015-07-16  Release Manager
 
 	* GCC 5.2.0 released.
Index: gcc/BASE-VER
===================================================================
--- gcc/BASE-VER	(.../tags/gcc_5_2_0_release)	(wersja 225879)
+++ gcc/BASE-VER	(.../branches/gcc-5-branch)	(wersja 225879)
@@ -1 +1 @@
-5.2.0
+5.2.1
